// Realy decoder proguram     by Henohenomoheji
//
//   Based on   Desktop Station Turnout Decoder 
//   By yaasan 20170802 version
//
//   Ver 0.0 2019-2-2  Add vehicle mode(sw1=ON)
//   Ver 0.1 2019-3-31 modify vehicle mode 車両番号でアクセサリを動かす機能を追加
//   Ver 0.2 2019-5-19 ＣＨ１，３，４の動作方向を訂正 

const char ver[]="0.2";
//
#include "NmraDcc_v141.h"
#include <avr/eeprom.h>   //required by notifyCVRead() function if enabled below

//各種設定、宣言
#define SD0 4
#define SD1 5
#define SD2 7
#define SD3 6
#define SEL0 8
#define SEL1  9
#define SEL2 10
// ポイント操作用
#define PIN_CH1D 14
#define PIN_CH1S 15
#define PIN_CH2D 16
#define PIN_CH2S 17
#define PIN_CH3D 18
#define PIN_CH3S 19
#define PIN_CH4D 13  // Prev pin NO is "2" (before patch wire)
#define PIN_CH4S 3
int PINOUT[]= {0,14,15,16,17,18,19,13,3};

// Class definition
NmraDcc  Dcc;
DCC_MSG  Packet;

//Task Schedule
unsigned long gPreviousL5 = 0;
extern void    notifyCVChange( uint16_t CV, uint8_t Value){
   //CVが変更されたときのメッセージ
   Serial.print("CV "); 
   Serial.print(CV); 
   Serial.print(" Changed to "); 
   Serial.println(Value, DEC);
};

// Configuration data from switch
uint8_t  conf = 0,rotary = 0;
void setup() {
  uint8_t cv_value;
  
  //start serial comm.
  Serial.begin(115200);
  Serial.print("Start Relay Decoder, Ver"); Serial.println( ver);

  digitalWrite(SEL0,HIGH);  digitalWrite(SEL1,HIGH);  digitalWrite(SEL2,HIGH);
  digitalWrite(SD0,HIGH);  digitalWrite(SD1,HIGH);  digitalWrite(SD2,HIGH);  digitalWrite(SD3,HIGH);
  pinMode(SEL0,OUTPUT);  pinMode(SEL1,OUTPUT);  pinMode(SEL2,OUTPUT);

  // Read switch
  digitalWrite(SEL2,LOW);
  conf += digitalRead(SD0);conf *=2;
  conf += digitalRead(SD1);conf *=2;
  conf += digitalRead(SD2);conf *=2;
  conf += digitalRead(SD3);conf *=2;
  digitalWrite(SEL2,HIGH);

  digitalWrite(SEL1,LOW);
  conf += digitalRead(SD0);conf *=2;
  conf += digitalRead(SD1);conf *=2;
  conf += digitalRead(SD2);conf *=2;
  conf += digitalRead(SD3);
  conf =255- conf;
  digitalWrite(SEL1,HIGH);
  
  digitalWrite(SEL0,LOW);
  rotary += digitalRead(SD3);rotary *=2;
  rotary += digitalRead(SD2);rotary *=2;
  rotary += digitalRead(SD1);rotary *=2;
  rotary += digitalRead(SD0);
  digitalWrite(SEL0,HIGH);
  rotary =15- rotary;

  Serial.print("RotarySW=");  Serial.print(rotary);
  Serial.print(",DipSW=");  Serial.println(conf);
 
  pinMode(PIN_CH1D,OUTPUT);  pinMode(PIN_CH1S,OUTPUT);
  pinMode(PIN_CH2D,OUTPUT);  pinMode(PIN_CH2S,OUTPUT);
  pinMode(PIN_CH3D,OUTPUT);  pinMode(PIN_CH3S,OUTPUT);
  pinMode(PIN_CH4D,OUTPUT);  pinMode(PIN_CH4S,OUTPUT);  

  // Setup which External Interrupt, the Pin it's associated with that we're using, disable pullup.
  Dcc.pin(0, 1, 0);
  
  // スイッチ設定１がＯＮの時は車両、ＯＦＦのときはアクセサリで動かす。
  if (conf & 0x01) {
    // Call the main DCC Init function to enable the DCC Receiver
    Dcc.init( 140 , 100,   FLAGS_MY_ADDRESS_ONLY , 0 ); 
    // アドレスをロータリースイッチ＋９００になるようにＣＶ値をセットする。
    //http://www.2mm.org.uk/articles/cv29%20calculator.htm
    // Dcc.setCV( 1,3);  // set short adrs
    Dcc.setCV( 29,33);  // long adrs mode 
    Dcc.setCV( 17,195);  // set long adrs   
    Dcc.setCV( 18,132+rotary);  // set longt adrs   
    Serial.print("Start vehicle mode,adrs is ");
    Serial.println(900+rotary);
  }
  else {
   if (conf & 0x80) { // No8=ON then initialize point direction
      delay(3000);
      digitalWrite(PIN_CH1D,HIGH);delay(100);  digitalWrite(PIN_CH1D,LOW);delay(3000);
      digitalWrite(PIN_CH1S,HIGH);delay(100);  digitalWrite(PIN_CH1S,LOW);delay(3000);
      digitalWrite(PIN_CH2D,HIGH);delay(100);  digitalWrite(PIN_CH2D,LOW);delay(3000);
      digitalWrite(PIN_CH2S,HIGH);delay(100);  digitalWrite(PIN_CH2S,LOW);delay(3000);
      digitalWrite(PIN_CH3D,HIGH);delay(100);  digitalWrite(PIN_CH3D,LOW);delay(3000);
      digitalWrite(PIN_CH3S,HIGH);delay(100);  digitalWrite(PIN_CH3S,LOW);delay(3000);
      digitalWrite(PIN_CH4D,HIGH);delay(100);  digitalWrite(PIN_CH4D,LOW);delay(3000);
      digitalWrite(PIN_CH4S,HIGH);delay(100);  digitalWrite(PIN_CH4S,LOW);delay(3000);
    }
    //  init(ManufacturerId, VersionId, Flags | FLAGS_DCC_ACCESSORY_DECODER, OpsModeAddressBaseCV);
    Dcc.init( 140, 10, FLAGS_OUTPUT_ADDRESS_MODE | FLAGS_DCC_ACCESSORY_DECODER, 0 );
    
    Serial.println("Start accesary mode");
  }
  //Reset task
  gPreviousL5 = millis();
}

void loop(){
  // You MUST call the NmraDcc.process() method frequently from the Arduino loop() function for correct library operation
  Dcc.process();
  // 100mSごとのタスク
  if( (millis() - gPreviousL5) >= 100) {
    gPreviousL5 = millis();
  }
}

extern void notifyDccSpeed( uint16_t Addr, DCC_ADDR_TYPE AddrType, uint8_t Speed, DCC_DIRECTION Dir, DCC_SPEED_STEPS SpeedSteps ){
  //　not used
}

extern void notifyDccFunc(uint16_t Addr, DCC_ADDR_TYPE AddrType, FN_GROUP FuncGrp, uint8_t FuncState) {
  switch(FuncGrp)  {
    case FN_0_4:  //Function Group 1 F0 F4 F3 F2 F1
      //exec_function( 0, FunctionPin0, (FuncState & FN_BIT_00)>>4 );
      exec_function( 1, PINOUT[1], (FuncState & FN_BIT_01));
      exec_function( 2, PINOUT[2], (FuncState & FN_BIT_02)>>1);
      exec_function( 3, PINOUT[3], (FuncState & FN_BIT_03)>>2 );
      exec_function( 4, PINOUT[4], (FuncState & FN_BIT_04)>>3 );
      break;

    case FN_5_8:  //Function Group 1 S FFFF == 1 F8 F7 F6 F5  &  == 0  F12 F11 F10 F9 F8
      exec_function( 5, PINOUT[5], (FuncState & FN_BIT_05));
      exec_function( 6, PINOUT[6], (FuncState & FN_BIT_06)>>1 );
      exec_function( 7, PINOUT[7], (FuncState & FN_BIT_07)>>2 );
      exec_function( 8, PINOUT[8], (FuncState & FN_BIT_08)>>3 );
      break;

    case FN_9_12:
      //exec_function( 9, FunctionPin9, (FuncState & FN_BIT_09));
      //exec_function( 10, FunctionPin10, (FuncState & FN_BIT_10)>>1 );
      //exec_function( 11, FunctionPin11, (FuncState & FN_BIT_11)>>2 );
      //exec_function( 12, FunctionPin12, (FuncState & FN_BIT_12)>>3 );
      break;

    case FN_13_20:   //Function Group 2 FuncState == F20-F13 Function Control
      //exec_function( 13, FunctionPin13, (FuncState & FN_BIT_13));
      //exec_function( 14, FunctionPin14, (FuncState & FN_BIT_14)>>1 );
      //exec_function( 15, FunctionPin15, (FuncState & FN_BIT_15)>>2 );
      //exec_function( 16, FunctionPin16, (FuncState & FN_BIT_16)>>3 );
      break;

    case FN_21_28:
      break;
      
  }
}
void exec_function (int function, int pin, int FuncState){
  digitalWrite (pin, FuncState);
}
// This function is called whenever a DCC Signal Aspect Packet is received
void notifyDccSigState( uint16_t Addr, uint8_t OutputIndex, uint8_t State) {
  Serial.print("notifyDccSigState: ") ;
  Serial.print(Addr,DEC) ;
  Serial.print(',');
  Serial.print(OutputIndex,DEC) ;
  Serial.print(',');
  Serial.println(State, HEX) ;

}
// This function is called whenever a normal DCC Turnout Packet is received
void notifyDccAccState( uint16_t Addr, uint16_t BoardAddr, uint8_t OutputAddr, uint8_t State)
{
  uint16_t aAccAdress = Addr;
  uint8_t aDir = (OutputAddr & 0b001);

  Serial.print("notifyDccAccState: ") ;
  Serial.print(Addr,DEC) ;
  Serial.print(",BAdr:");
  Serial.print(BoardAddr,DEC) ;
  Serial.print(",OAdr:");
  Serial.print(OutputAddr,DEC) ;
  Serial.print(", Target Adr:");
  Serial.print(aAccAdress,DEC) ;
  Serial.print(",");
  Serial.println(State, HEX) ;

  // Check borad address  
  if (BoardAddr == rotary+1) {
      switch (OutputAddr/2) {
        case 0:
          if (OutputAddr==0)   digitalWrite(PIN_CH1D,HIGH);   
          else   digitalWrite(PIN_CH1S,HIGH);  
          delay(100);   
          digitalWrite(PIN_CH1D,LOW); digitalWrite(PIN_CH1S,LOW);
          break;
        case 1:
          if (OutputAddr==2)   digitalWrite(PIN_CH2D,HIGH);
          else   digitalWrite(PIN_CH2S,HIGH);  
          delay(100);   digitalWrite(PIN_CH2D,LOW); digitalWrite(PIN_CH2S,LOW);
          break;
        case 2:
          if (OutputAddr==4)   digitalWrite(PIN_CH3D,HIGH);   
          else   digitalWrite(PIN_CH3S,HIGH);  
          delay(100);   digitalWrite(PIN_CH3D,LOW); digitalWrite(PIN_CH3S,LOW);
          break;
        case 3:
          if (OutputAddr==6)   digitalWrite(PIN_CH4D,HIGH);   
          else   digitalWrite(PIN_CH4S,HIGH);  
          delay(100);   digitalWrite(PIN_CH4D,LOW); digitalWrite(PIN_CH4S,LOW);
          break;
        default: break;
      }
  }
}
// End of fine
